GNU bug report logs - #42009
package cache build is not deterministic

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Marinus <marinus.savoritias@HIDDEN>; dated Mon, 22 Jun 2020 17:26:02 UTC; Maintainer for guix is bug-guix@HIDDEN.
Changed bug title to 'package cache build is not deterministic' from 'Determinism problem with guix pull' Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 29 Jun 2020 10:03:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 29 06:03:33 2020
Received: from localhost ([127.0.0.1]:48013 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jpqdR-0000zX-I8
	for submit <at> debbugs.gnu.org; Mon, 29 Jun 2020 06:03:33 -0400
Received: from mail-wr1-f54.google.com ([209.85.221.54]:39823)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1jpqdO-0000zJ-RN
 for 42009 <at> debbugs.gnu.org; Mon, 29 Jun 2020 06:03:32 -0400
Received: by mail-wr1-f54.google.com with SMTP id q5so15900251wru.6
 for <42009 <at> debbugs.gnu.org>; Mon, 29 Jun 2020 03:03:30 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=vpFrYE6ZX8flXGGiCKE6e7O7wGcGTp947n9Q+t4HoWQ=;
 b=Ok7FREbMIcaORQD8+STOlD916iw23q9a2vVJSJRO8yo5AKWL45PfWaN8IkUbcCO4/4
 F3+8wgzpWLLwHxWXWcckUPgDVyfocOMCYjx4adUFerhmtZ1iZsiX8kNGCACuBYeXf4W6
 N+Hmaf4ukur8dzXh40pfLJto2Bq/BoQHcAU6/sY7a4SIf1oQhQPQb80SjONkcmBcVA9o
 v0WU5NhLyWpBm9hClVG/w3GLr9DagTko1izUNEOtI9N1TrBNkPpcJXeCgZEJ507ih6ce
 dNZDVq6gBBmxfdn525VYgYJmvDW9Vjq51JM6oTIfCB4OeWODwAhTpx7gv/L4O03V9L4y
 hDvQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version:content-transfer-encoding;
 bh=vpFrYE6ZX8flXGGiCKE6e7O7wGcGTp947n9Q+t4HoWQ=;
 b=R5faTF2vVdxy2VQfaXvQYaIuRKsTdJ38aJkC0NHydb74yOF1mm7GAopl/AauNyQDI0
 800NO5aqFdWs4kyhLILftmhGbkmySAIAT/5mFohUDYoO+r73Ipnvzj1mxicKSc2ZGm2w
 BpOGcS6xGNN5wTEor/uuL9tGxpOjdCKfyZ85vaZSqSIoeFLyTcWTB3lZcUuH4V/WdOSA
 /AwoSGaFLe47LwD+McIiCTkXn4s1LC6clnfF2y/cH4hC2MhFX1Ox98ouCghhvzoyx6VH
 pygW2NIora+a522RAv+PjP2dgp36Q18WMbxiHrj/7ddTApY4g6S6Uf1jgK35qRjzMJ62
 8TSA==
X-Gm-Message-State: AOAM5329rhvFx1Lof2VpF+NRxcHcH3ltrUTDBPG7k78DkvgOaLzRc5jy
 HQBtMnqcM/SNd80OlSBaiQfaAWfCxxM=
X-Google-Smtp-Source: ABdhPJyArT6oKn3mObUDvDETtZj2uuNPYvzjvHfK6QhKBlnepHh+f6+WMMsWCHb2ZrtOkDVYyF8CJw==
X-Received: by 2002:adf:81c8:: with SMTP id 66mr16357699wra.348.1593425004446; 
 Mon, 29 Jun 2020 03:03:24 -0700 (PDT)
Received: from lili ([2a01:e0a:59b:9120:65d2:2476:f637:db1e])
 by smtp.gmail.com with ESMTPSA id r1sm14710460wrw.24.2020.06.29.03.03.22
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 29 Jun 2020 03:03:23 -0700 (PDT)
From: zimoun <zimon.toutoune@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: bug#42009: package.cache not deterministic
In-Reply-To: <874kqvgchu.fsf@HIDDEN>
References: <1593096834.1154.5@HIDDEN> <87h7uysrmr.fsf@nckx>
 <86366ibuor.fsf@HIDDEN> <874kqvgchu.fsf@HIDDEN>
Date: Mon, 29 Jun 2020 12:03:22 +0200
Message-ID: <86o8p2b34l.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 42009
Cc: 42009 <at> debbugs.gnu.org, Tobias Geerinckx-Rice <me@HIDDEN>,
 Marinus <marinus.savoritias@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Ludo,

On Sun, 28 Jun 2020 at 22:29, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:

> Most likely the problem with non-reproducible .go files is that the fix
> for <https://bugs.gnu.org/20272> was incomplete.  In particular, I think
> that gensyms are not reproducible when building things in parallel,
> because the gensym depends on what=E2=80=99s loaded vs. interpreted.

Thank you for the pointer.

How can I test the "hypothesis" of "building things in parallel"?

--8<---------------cut here---------------start------------->8---
guix describe -f channels > /tmp/chan.scm
guix pull -C /tmp/chan.scm --cores=3D1 -p /tmp/repull1

guix build --check --no-grafts --cores=3D1 \
     $(guix gc --derivers \
            $(readlink -f /tmp/repull1/lib/guix/package.cache))
The following profile hook will be built:
   /gnu/store/qbrgxbnx0hi13xm36a6a0zijzc1rcz22-guix-package-cache.drv
building package cache...
(repl-version 0 1 1)
Generating package cache for '/gnu/store/bgqy3mfpzbpyz3pysqxzkpch39q98yv3-p=
rofile'...
(values (value "/gnu/store/15nnwjqrmh5w9hqy9yp4ycxsyfbsr0wi-guix-package-ca=
che/lib/guix/package.cache"))
guix build: error: derivation `/gnu/store/qbrgxbnx0hi13xm36a6a0zijzc1rcz22-=
guix-package-cache.drv' may not be deterministic: output `/gnu/store/15nnwj=
qrmh5w9hqy9yp4ycxsyfbsr0wi-guix-package-cache' differs
--8<---------------cut here---------------end--------------->8---

BTW, I do not understand why the derivations have different hashes,
containing derivations with different hashes and more importantly, why
it is not the same order.

--8<---------------cut here---------------start------------->8---
guix gc --derivers $(readlink -f ~/.config/guix/current/lib/guix/package.ca=
che)
/gnu/store/0pmc85ni7zsd5jrflb0prrj7bhvn1m1y-guix-package-cache.drv

cat $(guix gc --derivers $(readlink -f ~/.config/guix/current/lib/guix/pack=
age.cache))
Derive
([("out","/gnu/store/pfpbh4v1m2dgn9dwiz6rsbqgx8lmd3ms-guix-package-cache","=
","")]
 ,[("/gnu/store/3pkfaqkdkaqy8khsfbsl0si3r9mydygl-profile.drv",["out"])
   ,("/gnu/store/nih4g42d2da8p2b5dmxqb081bbpv9ax4-inferior-script.scm.drv",=
["out"])
   ,("/gnu/store/x32cnfkd50fnxs10xp1jdn24h7ai2gxr-guile-3.0.2.drv",["out"])]
 ,["/gnu/store/50h7d8cx9k28gdbdzc9y615d1564m8ia-guix-package-cache-builder"]
 ,"x86_64-linux","/gnu/store/0m0vd873jp61lcm4xa3ljdgx381qa782-guile-3.0.2/b=
in/guile",["--no-auto-compile","/gnu/store/50h7d8cx9k28gdbdzc9y615d1564m8ia=
-guix-package-cache-builder"]
 ,[("guix properties","((type . profile-hook) (hook . package-cache))")
   ,("out","/gnu/store/pfpbh4v1m2dgn9dwiz6rsbqgx8lmd3ms-guix-package-cache")
   ,("preferLocalBuild","1")])
--8<---------------cut here---------------end--------------->8---

--8<---------------cut here---------------start------------->8---
guix gc --derivers $(readlink -f /tmp/repull1/lib/guix/package.cache)
/gnu/store/qbrgxbnx0hi13xm36a6a0zijzc1rcz22-guix-package-cache.drv

cat $(guix gc --derivers $(readlink -f /tmp/repull1/lib/guix/package.cache))
Derive
([("out","/gnu/store/15nnwjqrmh5w9hqy9yp4ycxsyfbsr0wi-guix-package-cache","=
","")]
 ,[("/gnu/store/b4dcaccqli2zdfalrn0lc0cz94gd80sk-inferior-script.scm.drv",[=
"out"])
   ,("/gnu/store/hm03mwl234lw43ivx33nsap0j4pjwqjp-profile.drv",["out"])
   ,("/gnu/store/x32cnfkd50fnxs10xp1jdn24h7ai2gxr-guile-3.0.2.drv",["out"])]
 ,["/gnu/store/251jkjnw9zza2zwr1k45x1049d1axl5q-guix-package-cache-builder"]
 ,"x86_64-linux","/gnu/store/0m0vd873jp61lcm4xa3ljdgx381qa782-guile-3.0.2/b=
in/guile",["--no-auto-compile","/gnu/store/251jkjnw9zza2zwr1k45x1049d1axl5q=
-guix-package-cache-builder"]
 ,[("guix properties","((type . profile-hook) (hook . package-cache))")
   ,("out","/gnu/store/15nnwjqrmh5w9hqy9yp4ycxsyfbsr0wi-guix-package-cache")
   ,("preferLocalBuild","1")])
--8<---------------cut here---------------end--------------->8---

And I am confused because if I repull again with '--cores=3D2', then,

--8<---------------cut here---------------start------------->8---
/tmp/repull1/bin/guix pull -C /tmp/chan.scm --cores=3D2 -p /tmp/repull2
md5sum \
  $(readlink -f /tmp/repull2/lib/guix/package.cache) \
  $(readlink -f /tmp/repull2/lib/guix/package.cache)
75f6feb9f52c312cc9cc8f73534926ba  /gnu/store/15nnwjqrmh5w9hqy9yp4ycxsyfbsr0=
wi-guix-package-cache/lib/guix/package.cache
75f6feb9f52c312cc9cc8f73534926ba  /gnu/store/15nnwjqrmh5w9hqy9yp4ycxsyfbsr0=
wi-guix-package-cache/lib/guix/package.cache
--8<---------------cut here---------------end--------------->8---

But '--check' fails in all cases.  What do I miss?


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 28 Jun 2020 20:30:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 28 16:30:01 2020
Received: from localhost ([127.0.0.1]:47051 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jpdw9-0007Wh-GD
	for submit <at> debbugs.gnu.org; Sun, 28 Jun 2020 16:30:01 -0400
Received: from eggs.gnu.org ([209.51.188.92]:58548)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1jpdw7-0007WU-Au
 for 42009 <at> debbugs.gnu.org; Sun, 28 Jun 2020 16:30:00 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47367)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1jpdw0-0005Do-Kr; Sun, 28 Jun 2020 16:29:52 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=42192 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1jpdvy-0007Aj-PL; Sun, 28 Jun 2020 16:29:52 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#42009: package.cache not deterministic
References: <1593096834.1154.5@HIDDEN> <87h7uysrmr.fsf@nckx>
 <86366ibuor.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 11 Messidor an 228 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sun, 28 Jun 2020 22:29:49 +0200
In-Reply-To: <86366ibuor.fsf@HIDDEN> (zimoun's message of "Fri, 26 Jun 2020
 01:19:00 +0200")
Message-ID: <874kqvgchu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 42009
Cc: 42009 <at> debbugs.gnu.org, Tobias Geerinckx-Rice <me@HIDDEN>,
 Marinus <marinus.savoritias@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

Most likely the problem with non-reproducible .go files is that the fix
for <https://bugs.gnu.org/20272> was incomplete.  In particular, I think
that gensyms are not reproducible when building things in parallel,
because the gensym depends on what=E2=80=99s loaded vs. interpreted.

Example of a simpler discrepancy:

--8<---------------cut here---------------start------------->8---
$ guix challenge guile-gcrypt
/gnu/store/i6zzgsjjlqyfn9zmanb55hqdackhc0mf-guile-gcrypt-0.3.0 contents dif=
fer:
  local hash: 0bkxim5532bd234iqxvxd31ybp6v7rmbrvyj3jrgpmgxbsw7hmxj
  https://ci.guix.gnu.org/nar/lzip/i6zzgsjjlqyfn9zmanb55hqdackhc0mf-guile-g=
crypt-0.3.0: 00zsccxn1485bnvxvssgq50i2w69i38m9hnrk8z1sji9qcmmaxcs
  differing files:
    /lib/guile/3.0/site-ccache/gcrypt/pk-crypto.go
    /lib/guile/3.0/site-ccache/gcrypt/mac.go
--8<---------------cut here---------------end--------------->8---

HTH!

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 25 Jun 2020 23:19:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 25 19:19:12 2020
Received: from localhost ([127.0.0.1]:41471 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1job9E-0007il-CF
	for submit <at> debbugs.gnu.org; Thu, 25 Jun 2020 19:19:12 -0400
Received: from mail-wr1-f46.google.com ([209.85.221.46]:39575)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1job9A-0007iV-OZ
 for 42009 <at> debbugs.gnu.org; Thu, 25 Jun 2020 19:19:10 -0400
Received: by mail-wr1-f46.google.com with SMTP id q5so7621082wru.6
 for <42009 <at> debbugs.gnu.org>; Thu, 25 Jun 2020 16:19:08 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-transfer-encoding;
 bh=lJ8qkvJ5JCsVyOh7xyonvMRrdhsBY5AfiL45fE1BWmg=;
 b=d3E+IVQXWow3+GoxQ2Ogwu27ZdD18bQI9NLD+KnpmazBsOxOuSVByqOan/9ZCQiFyS
 VTB0y8fIzxBQvXfv7RfICxYb2k04bsiDAq9CK5vJX/Tfgtma3B1L2jr7qB43IsDgPjTH
 w/mb6tLS7JmcYCaMGBCjNPZatDX7bYFH/7qwlDViFK3b2UvXzxk9+lgpFBuwfHD+XguZ
 RTfww/pb31MBG21MHYmZvT/tvHqkyZXpX8ZSfgRYPkn8saNk1JzCnPhkFE9esgea4Guv
 QhViurvW9MfvvqjObM1mQWGFsevSOTX7pjx+t83U1lkJkNiwvAfA/hoDprp+scsCgET+
 AxkQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version:content-transfer-encoding;
 bh=lJ8qkvJ5JCsVyOh7xyonvMRrdhsBY5AfiL45fE1BWmg=;
 b=Onj+UJ8e1HzYX2BOSq/qPV62XZXZwGyadT6+28zEHFc75sXZM+/cy2sSftO6SEIWpn
 cQ9fO6lYcNzSFj95GHFJ0HWmhvckJKaAvgWEIvNq8w5hwwH/BEiWtLEBKSZiR0SNWi4s
 tways+HA84cZWmg0J8/i1w/RBnpgyLz01dcTBbwVSUTb1vA8VekKetcyvqtEGorejHVQ
 BVX5+rsJYYG969EaX11Vb8bYDL8MNSnCS88Hw0kimGb9TXfkZpr0MqpAKlPuGshQCMMS
 D72LD00nEQVhvFWOMqI3oCSULotK/9d24i/UbVotEe2yahu7PAO+tERCkKnduxUTMZMG
 nuQw==
X-Gm-Message-State: AOAM530/ns7To1EiHPGNf78Vpu2sw6q5yVvuaQKlyAOANXAQGDe0JmcP
 xzqLK5H0VDQatiOai6LHeLqpthfN2Nk=
X-Google-Smtp-Source: ABdhPJybBcsJQagAvEoTnqM3wuxaSRiISDfYqGbeHvKCf4KcGSnD8sutgs6DYwfABBYCtLbhbFkmZA==
X-Received: by 2002:adf:df10:: with SMTP id y16mr583820wrl.225.1593127142561; 
 Thu, 25 Jun 2020 16:19:02 -0700 (PDT)
Received: from lili ([2a01:e0a:59b:9120:65d2:2476:f637:db1e])
 by smtp.gmail.com with ESMTPSA id r10sm16764240wrm.17.2020.06.25.16.19.01
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 25 Jun 2020 16:19:01 -0700 (PDT)
From: zimoun <zimon.toutoune@HIDDEN>
To: Tobias Geerinckx-Rice <me@HIDDEN>,
 Marinus <marinus.savoritias@HIDDEN>
Subject: Re: bug#42009: package.cache not deterministic
In-Reply-To: <87h7uysrmr.fsf@nckx>
References: <1593096834.1154.5@HIDDEN> <87h7uysrmr.fsf@nckx>
Date: Fri, 26 Jun 2020 01:19:00 +0200
Message-ID: <86366ibuor.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 42009
Cc: 42009 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Tobias,

On Fri, 26 Jun 2020 at 00:33, Tobias Geerinckx-Rice <me@HIDDEN> wrote:

> Seems like a =E2=80=98simple=E2=80=99 case of the packages not being orde=
red=20
> (enough):

So one culprit would be 'scandir*' from 'scheme-files' used by
'scheme-modules' used by 'all-modules' used by 'generate-package-cache'.
The docstring says: "The returned list is sorted in alphabetical order."

Well, I will try to investigate more.

> https://www.tobias.gr/guix-package.cache.diffoscope.html/#lib---guix---pa=
ckage.cache---strings---all---

Interesting...

Good night,
simon




Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 25 Jun 2020 22:33:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 25 18:33:15 2020
Received: from localhost ([127.0.0.1]:41460 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1joaQl-0006es-28
	for submit <at> debbugs.gnu.org; Thu, 25 Jun 2020 18:33:15 -0400
Received: from tobias.gr ([80.241.217.52]:58364)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1joaQi-0006ej-1q
 for 42009 <at> debbugs.gnu.org; Thu, 25 Jun 2020 18:33:13 -0400
Received: by tobias.gr (OpenSMTPD) with ESMTP id ef19fe0c;
 Thu, 25 Jun 2020 22:33:10 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed; d=tobias.gr; h=from:to:cc
 :subject:references:in-reply-to:date:message-id:mime-version
 :content-type; s=2018; i=me@HIDDEN; bh=bLRQjsCsdMTr9EFWJRA73K
 rxIpZsXMPINQsowIA+xmI=; b=hJBokYdvluvPa4SbcGX7fvAo6w3pP3nQixUmI9
 pSBKkWK0Z6OewUjwNwrZ+z0Iq7pQZKeL7xAu6ZhXGQaPjNewBZ8WJZFeZ9GnA4vK
 iyUJh81Ci1v4HhsyD937USs9omAtVMIno6JZdaHr7ZH3aVJ1twwLwx+M8uQN8azS
 5bisGVeIH5DI9FNGLesaffirMDG3CAVKZpMgcnVmibop9mSUbnK6ZEfP90Z00uif
 0ZJIYv9eQdTCbhj+3d49pSxvze02CNr4guzQKzF3gjjQYwJl4M3ysqfXMLbzWeYr
 OqJYZp0NW1jtSrkWy6Nw+nzAeox1CnDrroyQ2OZlvlaYz7sQ==
Received: by submission.tobias.gr (OpenSMTPD) with ESMTPSA id 0bf55551
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256:NO); 
 Thu, 25 Jun 2020 22:33:07 +0000 (UTC)
BIMI-Selector: v=BIMI1; s=default;
From: Tobias Geerinckx-Rice <me@HIDDEN>
To: Marinus <marinus.savoritias@HIDDEN>
Subject: Re: bug#42009: package.cache not deterministic
References: <1593096834.1154.5@HIDDEN>
In-reply-to: <86ftalqu37.fsf@HIDDEN>
Date: Fri, 26 Jun 2020 00:33:00 +0200
Message-ID: <87h7uysrmr.fsf@nckx>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 42009
Cc: 42009 <at> debbugs.gnu.org, zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Quick and lazy reply before the sleep comes,

Seems like a =E2=80=98simple=E2=80=99 case of the packages not being ordere=
d=20
(enough):=20
https://www.tobias.gr/guix-package.cache.diffoscope.html/#lib---guix---pack=
age.cache---strings---all---

(Sorry for the ad-hoc URL, I'll keep it up until this bug report=20
is closed!)

Kind regards,

T G-R

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iHUEARYKAB0WIQT12iAyS4c9C3o4dnINsP+IT1VteQUCXvUmHAAKCRANsP+IT1Vt
eROyAP9a+GfV3vB/T5kwqyymDb+rsyRauI4tfaHKPK/WmxVU6wD/bH0XaRN85fMA
w+3V8AiWHAREz3a1UqR6FCYmqzLXfA0=
=as+f
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 25 Jun 2020 14:54:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 25 10:54:00 2020
Received: from localhost ([127.0.0.1]:40897 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1joTGK-0007AS-66
	for submit <at> debbugs.gnu.org; Thu, 25 Jun 2020 10:54:00 -0400
Received: from knopi.disroot.org ([178.21.23.139]:54252)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <marinus.savoritias@HIDDEN>) id 1joTGI-0007AJ-34
 for 42009 <at> debbugs.gnu.org; Thu, 25 Jun 2020 10:53:59 -0400
Received: from localhost (localhost [127.0.0.1])
 by disroot.org (Postfix) with ESMTP id 5E98D5524F;
 Thu, 25 Jun 2020 16:53:57 +0200 (CEST)
X-Virus-Scanned: Debian amavisd-new at disroot.org
Received: from knopi.disroot.org ([127.0.0.1])
 by localhost (disroot.org [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id zNrt5eF5fdn7; Thu, 25 Jun 2020 16:53:56 +0200 (CEST)
Date: Thu, 25 Jun 2020 16:53:54 +0200
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=disroot.org; s=mail;
 t=1593096835; bh=6d5nOdrU2GhZuz/OuRxvTVijKDkrjbR0H3LfeJGs22Q=;
 h=Date:From:Subject:To:Cc:In-Reply-To:References;
 b=WK7sBHTKBqyFJYo4YQMbI/61j+28g0M/Y3bABPEuxcTEWsAH6F9LFxa36sQX+1YPU
 GlCmuHErXPumXYpGSEnuFrCHegKNnNmLobCrLKH7DJbM9AP/yAiHkgUK+OUXGLqgXw
 AW1OlmbC9Ytm3oB2hZ0VkZJkLkZIsMem/OVB6Y+L7z3eaBOnyiTZFRlAJ/pdWkiSTy
 pYvZ1H5nJDL3BNB3Mi6ZnYJfS647Xm1MF8tVQS06YjfMMrdTj4WLd74xBGfKigCImp
 M4ILMCBtOLeSSCCcFymvvvwpd8t7bRQHRp3leDdX5B5WXsFrmuExRw89VyaOKFPZl1
 qICOxeDkZrCrQ==
From: Msavoritias <marinus.savoritias@HIDDEN>
Subject: Re: bug#42009: package.cache not deterministic
To: zimoun <zimon.toutoune@HIDDEN>
Message-Id: <1593096834.1154.5@HIDDEN>
In-Reply-To: <86zh8rbjnz.fsf@HIDDEN>
References: <20200622190742.04a62732@HIDDEN> <86ftalqu37.fsf@HIDDEN>
 <1593025157.3861.2@HIDDEN> <86zh8rbjnz.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: multipart/alternative; boundary="=-4Jw+pJy7EpxPjfE8h1Ut"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 42009
Cc: 42009 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-4Jw+pJy7EpxPjfE8h1Ut
Content-Type: text/plain; charset=us-ascii; format=flowed

Is there any tests or any more information I can do on my side?

Marinus

On Thu, Jun 25, 2020 at 11:04, zimoun <zimon.toutoune@HIDDEN> wrote:
> Dear,
> 
> On Wed, 24 Jun 2020 at 20:59, Msavoritias 
> <marinus.savoritias@HIDDEN 
> <mailto:marinus.savoritias@HIDDEN>> wrote:
> 
>>  Do you suggest this bug should be filed against Guile?
> 
> Well, first the origin of the bug should be confirmed.  :-)
> And maybe there is an option for 'compile'.  I do not know.
> 
> All the best,
> simon


--=-4Jw+pJy7EpxPjfE8h1Ut
Content-Type: text/html; charset=us-ascii

<div id="geary-body" dir="auto"><div>Is there any tests or any more information I can do on my side?</div><div><br></div><div>Marinus</div></div><div id="geary-quote" dir="auto"><br>On Thu, Jun 25, 2020 at 11:04, zimoun &lt;zimon.toutoune@HIDDEN&gt; wrote:<br><blockquote type="cite"><div class="plaintext" style="white-space: pre-wrap;">Dear,

On Wed, 24 Jun 2020 at 20:59, Msavoritias &lt;<a href="mailto:marinus.savoritias@HIDDEN">marinus.savoritias@HIDDEN</a>&gt; wrote:

<blockquote> Do you suggest this bug should be filed against Guile?
</blockquote>
Well, first the origin of the bug should be confirmed.  :-)
And maybe there is an option for 'compile'.  I do not know.

All the best,
simon
</div></blockquote></div>
--=-4Jw+pJy7EpxPjfE8h1Ut--





Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 25 Jun 2020 09:04:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 25 05:04:59 2020
Received: from localhost ([127.0.0.1]:39692 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1joNoZ-0000DA-C3
	for submit <at> debbugs.gnu.org; Thu, 25 Jun 2020 05:04:59 -0400
Received: from mail-wm1-f51.google.com ([209.85.128.51]:51757)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1joNoX-0000Cx-Co
 for 42009 <at> debbugs.gnu.org; Thu, 25 Jun 2020 05:04:58 -0400
Received: by mail-wm1-f51.google.com with SMTP id 22so4787134wmg.1
 for <42009 <at> debbugs.gnu.org>; Thu, 25 Jun 2020 02:04:57 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version; bh=nilnfnvtZFJYIo/kGddXq66bL4FcbWWTE5yM7cTXGmg=;
 b=sW8Jcw/7n9kbeEgHhRznUWibVwkrXiaTtDhtiGzl1VoG+20gIf/duOcgr9kEMhK37F
 Yk79LjZMvxo5c8Uoj36Rn3GcR1dK8oCz0EppMDxEVTUjQcLWub/q5aVGO+ab17XbBIdJ
 p/UWO36QIfJwfLrtSLYwTd32F8ghVprZoApMND3YLhIZOBtjup418Rw9EbpKnpVDKaaR
 vnbABRpRoDK74c3ffqkwcOQWUktVg5TqdihRiBvFSJ5DDhW+ql96MNwBgkunjzEYFcvX
 S8rBbZuBND2gvm+fzHGbE1IW1Y4dlrlIv5rel9QERQrivQ1bA1uWtva40FbqjfUx28QQ
 p1Jg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version;
 bh=nilnfnvtZFJYIo/kGddXq66bL4FcbWWTE5yM7cTXGmg=;
 b=cci3aPqkpKJIh0veK09BifwVg+t6hFAUlsv7hZ8gUvNc1bkBVARe7Ef8C4uhOUpiv8
 90vKY4Lh5qoITPJ7ujgEon81ASTDs0qx7GL89odeIEzN3K1TYofg5Nw+iwdt6RkRQ7RL
 RIAOJIw9wBL39WXG4VvAEoAXEWzYs3uaEcFsU2m1QhlSlTqdm37Kl0fwxlZTm1koyrN6
 mgiDLdwiATkX4pKe0YUlGok6fq2fkMKMgoOE7ka9BI+jUTBni396HFkfLBXUGAU1PSOl
 X6zkXX7YDOOUj0CONj/Xbc+HmsPntw4w2El2lxizSsW9tWGA+RPzZH6fDEA2qarsPO9y
 mbsw==
X-Gm-Message-State: AOAM531lmTVoWC6gdtoLK7vK9wLwJsckFZWOuNNfZlYSUuiFOtRg1X17
 pgBD9kR2Ry/ueMDGEeKtnGe6WT59iic=
X-Google-Smtp-Source: ABdhPJyiNHJhEPJgIuvi3WlHsYlqU8hZ8ZoMA+DvyqyyErO35ntSM2Fpg6DUHpQOCpuwJrW0Shk9mg==
X-Received: by 2002:a1c:e910:: with SMTP id q16mr2222184wmc.188.1593075891106; 
 Thu, 25 Jun 2020 02:04:51 -0700 (PDT)
Received: from lili ([2a01:e0a:59b:9120:65d2:2476:f637:db1e])
 by smtp.gmail.com with ESMTPSA id 104sm31475344wrl.25.2020.06.25.02.04.49
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 25 Jun 2020 02:04:50 -0700 (PDT)
From: zimoun <zimon.toutoune@HIDDEN>
To: Msavoritias <marinus.savoritias@HIDDEN>
Subject: Re: bug#42009: package.cache not deterministic
In-Reply-To: <1593025157.3861.2@HIDDEN>
References: <20200622190742.04a62732@HIDDEN> <86ftalqu37.fsf@HIDDEN>
 <1593025157.3861.2@HIDDEN>
Date: Thu, 25 Jun 2020 11:04:48 +0200
Message-ID: <86zh8rbjnz.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 42009
Cc: 42009 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Dear,

On Wed, 24 Jun 2020 at 20:59, Msavoritias <marinus.savoritias@HIDDEN> wrote:

> Do you suggest this bug should be filed against Guile?

Well, first the origin of the bug should be confirmed.  :-)
And maybe there is an option for 'compile'.  I do not know.

All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 24 Jun 2020 21:40:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 24 17:40:07 2020
Received: from localhost ([127.0.0.1]:39246 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1joD7m-0006bI-Ib
	for submit <at> debbugs.gnu.org; Wed, 24 Jun 2020 17:40:07 -0400
Received: from knopi.disroot.org ([178.21.23.139]:53440)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <marinus.savoritias@HIDDEN>) id 1joAcE-0002cr-CT
 for 42009 <at> debbugs.gnu.org; Wed, 24 Jun 2020 14:59:23 -0400
Received: from localhost (localhost [127.0.0.1])
 by disroot.org (Postfix) with ESMTP id C006D4821E;
 Wed, 24 Jun 2020 20:59:20 +0200 (CEST)
X-Virus-Scanned: Debian amavisd-new at disroot.org
Received: from knopi.disroot.org ([127.0.0.1])
 by localhost (disroot.org [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id ij0kQxSFptUB; Wed, 24 Jun 2020 20:59:18 +0200 (CEST)
Date: Wed, 24 Jun 2020 20:59:17 +0200
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=disroot.org; s=mail;
 t=1593025158; bh=4ykDRo8JuCrHkzsD8hytWsiXonF1DwFlr2n7YE0R7eQ=;
 h=Date:From:Subject:To:Cc:In-Reply-To:References;
 b=UPIR/9kjHtDYBHtiMQRt/s0ycfACKHr0sf1mPOgrkNFClYN82UEU/HupawTWEfFI5
 s8ZtenonxI5x1eFfkMeYoODmhg5oxqipy+gcNCIfZJ/TuPJFtlmtC6lP1TZhU1cj5L
 Kgsuhly4kQ5T7hMs0tQEZKC4d2ZseEgp4w5TuqB2HHFPZ+XUzxSiAxr00obZM/tlDn
 9oqyETIBdYthYjS1zQJyJKinTPK+ebGg5MptiGNt3KqI7HW9cYfpNh1K/Zlcbm2Vob
 mrRrJvfTgtMIQ7Wupy5qebxEEhySG44p9oL0j7kesAdCdE6Onty/0PkxvuRV6pvshT
 8Vc3zSnfALa0w==
From: Msavoritias <marinus.savoritias@HIDDEN>
Subject: Re: bug#42009: package.cache not deterministic
To: zimoun <zimon.toutoune@HIDDEN>
Message-Id: <1593025157.3861.2@HIDDEN>
In-Reply-To: <86ftalqu37.fsf@HIDDEN>
References: <20200622190742.04a62732@HIDDEN> <86ftalqu37.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: multipart/alternative; boundary="=-8jj3MTje5Ex8fXeBTM41"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 42009
X-Mailman-Approved-At: Wed, 24 Jun 2020 17:40:05 -0400
Cc: 42009 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-8jj3MTje5Ex8fXeBTM41
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Hi,

Yeah seems like it. Although I have to admit I'm pretty newbie in a lot=20
of this stuff.
Do you suggest this bug should be filed against Guile?

Marinus

On Wed, Jun 24, 2020 at 00:46, zimoun <zimon.toutoune@HIDDEN> wrote:
> Dear,
>=20
> Thank you for the bug report.  It is something already noticed [1] but
> without a clean bug report to track it. :-)
>=20
> 1: <http://issues.guix.gnu.org/issue/39258#86>
>=20
>=20
> On Mon, 22 Jun 2020 at 19:07, Marinus <marinus.savoritias@HIDDEN=20
> <mailto:marinus.savoritias@HIDDEN>> wrote:
>=20
>>  Run into a determinism problem today with guix pull.
>>  I run guix pull --rounds=3D3 but guix ended in error that the result
>>  wasn't the same.
>=20
> For reproducing, the simplest is:
>=20
> --8<---------------cut here---------------start------------->8---
> $ guix build --check --no-grafts -K \
>    $(guix gc --derivers \
>       $(readlink -f ~/.config/guix/current/lib/guix/package.cache))
> The following profile hooks will be built:
>    /gnu/store/l50sinckbl1y0fz2y4yk4vvfdvay9c8l-guix-package-cache.drv
>    /gnu/store/h69hdf14c11q7dip0gssfd4cv0qw8j7k-guix-package-cache.drv
> building package cache...
> (repl-version 0 1 1)
> Generating package cache for=20
> '/gnu/store/67zi87xwv2d90kx8pzxsbw2q7qkh11ns-profile'...
> (values (value=20
> "/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache/lib/guix/=
package.cache"))
> guix build: error: derivation=20
> `/gnu/store/h69hdf14c11q7dip0gssfd4cv0qw8j7k-guix-package-cache.drv'=20
> may not be deterministic: output=20
> `/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache'=20
> differs
> --8<---------------cut here---------------end--------------->8---
>=20
> Then the usual "diffoscope":
>=20
> --8<---------------cut here---------------start------------->8---
> diffoscope \
> /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache/lib/guix/p=
ackage.cache=20
> \
> /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache-check/lib/=
guix/package.cache\
>   | head -n50
> --8<---------------cut here---------------end--------------->8---
>=20
> outputs something like:
>=20
> --8<---------------cut here---------------start------------->8---
> ---=20
> /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache/lib/guix/p=
ackage.cache
> +++=20
> /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache-check/lib/=
guix/package.cache
> =E2=94=9C=E2=94=80=E2=94=80 readelf --wide --file-header {}
> =E2=94=82 @@ -6,15 +6,15 @@
> =E2=94=82    OS/ABI:                            <unknown: ff>
> =E2=94=82    ABI Version:                       0
> =E2=94=82    Type:                              DYN (Shared object file)
> =E2=94=82    Machine:                           None
> =E2=94=82    Version:                           0x1
> =E2=94=82    Entry point address:               0x0
> =E2=94=82    Start of program headers:          64 (bytes into file)
> =E2=94=82 -  Start of section headers:          4900296 (bytes into file)
> =E2=94=82 +  Start of section headers:          4900456 (bytes into file)
> =E2=94=82    Flags:                             0x0
> =E2=94=82    Size of this header:               64 (bytes)
> =E2=94=82    Size of program headers:           56 (bytes)
> =E2=94=82    Number of program headers:         3
> =E2=94=82    Size of section headers:           64 (bytes)
> =E2=94=82    Number of section headers:         20
> =E2=94=82    Section header string table index: 17
> =E2=94=9C=E2=94=80=E2=94=80 readelf --wide --program-header {}
> =E2=94=82 @@ -1,16 +1,16 @@
> =E2=94=82
> =E2=94=82  Elf file type is DYN (Shared object file)
> =E2=94=82  Entry point 0x0
> =E2=94=82  There are 3 program headers, starting at offset 64
> =E2=94=82
> =E2=94=82  Program Headers:
> =E2=94=82    Type           Offset   VirtAddr           PhysAddr         =
 =20
> FileSiz  MemSiz   Flg Align
> =E2=94=82 -  LOAD           0x000000 0x0000000000000000 0x000000000000000=
0=20
> 0x286a68 0x286a68 R   0x10000
> =E2=94=82 -  LOAD           0x290000 0x0000000000290000 0x000000000029000=
0=20
> 0x21c5c8 0x21c5c8 RW  0x10000
> =E2=94=82 -  DYNAMIC        0x286a08 0x0000000000286a08 0x0000000000286a0=
8=20
> 0x000060 0x000060 R   0x8
> =E2=94=82 +  LOAD           0x000000 0x0000000000000000 0x000000000000000=
0=20
> 0x286b78 0x286b78 R   0x10000
> =E2=94=82 +  LOAD           0x290000 0x0000000000290000 0x000000000029000=
0=20
> 0x21c668 0x21c668 RW  0x10000
> =E2=94=82 +  DYNAMIC        0x286b18 0x0000000000286b18 0x0000000000286b1=
8=20
> 0x000060 0x000060 R   0x8
> =E2=94=82
> =E2=94=82   Section to Segment mapping:
> =E2=94=82    Segment Sections...
> =E2=94=82     00     .rodata .rtl-text .dynamic
> =E2=94=82     01     .data
> =E2=94=82     02     .dynamic
> =E2=94=9C=E2=94=80=E2=94=80 readelf --wide --sections {}
> =E2=94=82=E2=94=84 stderr from `readelf --wide --sections {}`:
> =E2=94=82=E2=94=84 readelf: Warning: [ 5]: Link field (0) should index a =
string=20
> section.
> =E2=94=82 @@ -1,29 +1,29 @@
> =E2=94=82 -There are 20 section headers, starting at offset 0x4ac5c8:
> =E2=94=82 +There are 20 section headers, starting at offset 0x4ac668:
> --8<---------------cut here---------------end--------------->8---
>=20
> Well, I do not know what should the next step.  I mean this
> "package.cache" file is created by the function
> gnu/packages.scm:(generate-package-cache) which reads:
>=20
> --8<---------------cut here---------------start------------->8---
>       ;; Store the cache as a '.go' file.  This makes loading fast=20
> and reduces
>       ;; heap usage since some of the static data is directly mmapped.
>       (put-bytevector port
>                       (compile `'(,@exp)
>                                #:to 'bytecode
>                                #:opts '(#:to-file? #t)))))
> --8<---------------cut here---------------end--------------->8---
>=20
> Then it is on the Guile side, isn't it?
>=20
>=20
> All the best,
> simon

=

--=-8jj3MTje5Ex8fXeBTM41
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div id=3D"geary-body" dir=3D"auto">Hi,<div><br></div><div>Yeah seems like =
it. Although I have to admit I'm pretty newbie in a lot of this stuff.</div=
><div>Do you suggest this bug should be filed against Guile?</div><div><br>=
</div><div>Marinus</div></div><div id=3D"geary-quote" dir=3D"auto"><br>On W=
ed, Jun 24, 2020 at 00:46, zimoun &lt;zimon.toutoune@HIDDEN&gt; wrote:<b=
r><blockquote type=3D"cite"><div class=3D"plaintext" style=3D"white-space: =
pre-wrap;">Dear,

Thank you for the bug report.  It is something already noticed [1] but
without a clean bug report to track it. :-)

1: <a href=3D"http://issues.guix.gnu.org/issue/39258#86">http://issues.guix=
.gnu.org/issue/39258#86</a>


On Mon, 22 Jun 2020 at 19:07, Marinus &lt;<a href=3D"mailto:marinus.savorit=
ias@HIDDEN">marinus.savoritias@HIDDEN</a>&gt; wrote:

<blockquote> Run into a determinism problem today with guix pull.
 I run guix pull --rounds=3D3 but guix ended in error that the result
 wasn't the same.
</blockquote>
For reproducing, the simplest is:

--8&lt;---------------cut here---------------start-------------&gt;8---
$ guix build --check --no-grafts -K \
   $(guix gc --derivers \
      $(readlink -f ~/.config/guix/current/lib/guix/package.cache))
The following profile hooks will be built:
   /gnu/store/l50sinckbl1y0fz2y4yk4vvfdvay9c8l-guix-package-cache.drv
   /gnu/store/h69hdf14c11q7dip0gssfd4cv0qw8j7k-guix-package-cache.drv
building package cache...
(repl-version 0 1 1)
Generating package cache for '/gnu/store/67zi87xwv2d90kx8pzxsbw2q7qkh11ns-p=
rofile'...
(values (value "/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-ca=
che/lib/guix/package.cache"))
guix build: error: derivation `/gnu/store/h69hdf14c11q7dip0gssfd4cv0qw8j7k-=
guix-package-cache.drv' may not be deterministic: output `/gnu/store/0009wh=
xhfz00lm027wbars8q4wb3rvia-guix-package-cache' differs
--8&lt;---------------cut here---------------end---------------&gt;8---

Then the usual "diffoscope":

--8&lt;---------------cut here---------------start-------------&gt;8---
diffoscope \
/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache/lib/guix/pac=
kage.cache \
/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache-check/lib/gu=
ix/package.cache\
  | head -n50
--8&lt;---------------cut here---------------end---------------&gt;8---

outputs something like:

--8&lt;---------------cut here---------------start-------------&gt;8---
--- /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache/lib/guix=
/package.cache
+++ /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache-check/li=
b/guix/package.cache
=E2=94=9C=E2=94=80=E2=94=80 readelf --wide --file-header {}
=E2=94=82 @@ -6,15 +6,15 @@
=E2=94=82    OS/ABI:                            &lt;unknown: ff&gt;
=E2=94=82    ABI Version:                       0
=E2=94=82    Type:                              DYN (Shared object file)
=E2=94=82    Machine:                           None
=E2=94=82    Version:                           0x1
=E2=94=82    Entry point address:               0x0
=E2=94=82    Start of program headers:          64 (bytes into file)
=E2=94=82 -  Start of section headers:          4900296 (bytes into file)
=E2=94=82 +  Start of section headers:          4900456 (bytes into file)
=E2=94=82    Flags:                             0x0
=E2=94=82    Size of this header:               64 (bytes)
=E2=94=82    Size of program headers:           56 (bytes)
=E2=94=82    Number of program headers:         3
=E2=94=82    Size of section headers:           64 (bytes)
=E2=94=82    Number of section headers:         20
=E2=94=82    Section header string table index: 17
=E2=94=9C=E2=94=80=E2=94=80 readelf --wide --program-header {}
=E2=94=82 @@ -1,16 +1,16 @@
=E2=94=82 =20
=E2=94=82  Elf file type is DYN (Shared object file)
=E2=94=82  Entry point 0x0
=E2=94=82  There are 3 program headers, starting at offset 64
=E2=94=82 =20
=E2=94=82  Program Headers:
=E2=94=82    Type           Offset   VirtAddr           PhysAddr           =
FileSiz  MemSiz   Flg Align
=E2=94=82 -  LOAD           0x000000 0x0000000000000000 0x0000000000000000 =
0x286a68 0x286a68 R   0x10000
=E2=94=82 -  LOAD           0x290000 0x0000000000290000 0x0000000000290000 =
0x21c5c8 0x21c5c8 RW  0x10000
=E2=94=82 -  DYNAMIC        0x286a08 0x0000000000286a08 0x0000000000286a08 =
0x000060 0x000060 R   0x8
=E2=94=82 +  LOAD           0x000000 0x0000000000000000 0x0000000000000000 =
0x286b78 0x286b78 R   0x10000
=E2=94=82 +  LOAD           0x290000 0x0000000000290000 0x0000000000290000 =
0x21c668 0x21c668 RW  0x10000
=E2=94=82 +  DYNAMIC        0x286b18 0x0000000000286b18 0x0000000000286b18 =
0x000060 0x000060 R   0x8
=E2=94=82 =20
=E2=94=82   Section to Segment mapping:
=E2=94=82    Segment Sections...
=E2=94=82     00     .rodata .rtl-text .dynamic =20
=E2=94=82     01     .data=20
=E2=94=82     02     .dynamic
=E2=94=9C=E2=94=80=E2=94=80 readelf --wide --sections {}
=E2=94=82=E2=94=84 stderr from `readelf --wide --sections {}`:
=E2=94=82=E2=94=84 readelf: Warning: [ 5]: Link field (0) should index a st=
ring section.
=E2=94=82 @@ -1,29 +1,29 @@
=E2=94=82 -There are 20 section headers, starting at offset 0x4ac5c8:
=E2=94=82 +There are 20 section headers, starting at offset 0x4ac668:
--8&lt;---------------cut here---------------end---------------&gt;8---

Well, I do not know what should the next step.  I mean this
"package.cache" file is created by the function
gnu/packages.scm:(generate-package-cache) which reads:

--8&lt;---------------cut here---------------start-------------&gt;8---
      ;; Store the cache as a '.go' file.  This makes loading fast and redu=
ces
      ;; heap usage since some of the static data is directly mmapped.
      (put-bytevector port
                      (compile `'(,@exp)
                               #:to 'bytecode
                               #:opts '(#:to-file? #t)))))
--8&lt;---------------cut here---------------end---------------&gt;8---

Then it is on the Guile side, isn't it?=20


All the best,
simon
</div></blockquote></div>=

--=-8jj3MTje5Ex8fXeBTM41--





Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at 42009 <at> debbugs.gnu.org:


Received: (at 42009) by debbugs.gnu.org; 23 Jun 2020 22:46:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 23 18:46:15 2020
Received: from localhost ([127.0.0.1]:37383 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jnrgF-0000Nf-GS
	for submit <at> debbugs.gnu.org; Tue, 23 Jun 2020 18:46:15 -0400
Received: from mail-wm1-f52.google.com ([209.85.128.52]:33832)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1jnrgC-0000NP-8L
 for 42009 <at> debbugs.gnu.org; Tue, 23 Jun 2020 18:46:14 -0400
Received: by mail-wm1-f52.google.com with SMTP id u26so3190310wmn.1
 for <42009 <at> debbugs.gnu.org>; Tue, 23 Jun 2020 15:46:12 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:subject:in-reply-to:references:date:message-id:mime-version
 :content-transfer-encoding;
 bh=h8yBNrNO/0f0dTWJdR5ohlgjUPiuxZNhS8rMClnmIFI=;
 b=DeM52RfYpZyvGqsjJurbHChVgWBG34S0YEAMrPMaE+T61Dug95YHe/MVi/VORqm9Pa
 fRBpHZw9epYGkq+g4XTjpllYWOb/G7lheI4UT8n/AJOJTlDEIT4qftbgYn5kP4VhRKAu
 MFAKz6tRJIVXzGx357u29kePr7jfRGN5FV9fI4i9o8WMwsmYAQGtT8EjdWt0tXcGjkTS
 9Izp2FWDmf+XNpM1YomBnehIFxb7XQCteWi468TGYHj6mS5Dnf65lrvwilCol82hOcOD
 345QZ3r5zWqiR1eU6abGhUQdG5wp371lIdY4K/tKvNrPouSU+MeqZmMSkan8biljz4ta
 wSGw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:in-reply-to:references:date
 :message-id:mime-version:content-transfer-encoding;
 bh=h8yBNrNO/0f0dTWJdR5ohlgjUPiuxZNhS8rMClnmIFI=;
 b=AKCJloQ7UM3lK1ik6c2EfyrfL6X9ElXVbK0Ooie4LSqeAXMbbq7/7LD8rZZTWjctpx
 g0OB59qhNKO7H94ylqCn2vGJuRMjx1HrC1BpCkgFCcyU3H3V3jMgYO0vqzYJggbLeU9B
 FKyg0XNtBg1H4n+4dktJx+h2zIjNq8D6PcDO6BhbsSkphpsci5+CUWfZ+bfU60dKQvB3
 MRzEwN4oxDYrAsxDisBS+0O86OZQWfF1m7z66TfxB5cU8B8KYyJBkEX/B/BkJMOGbdQQ
 XGNoEi5eJCtuvm6GOumXDycX8D0lal5/37TSUxanVTtaSNVIvEyt5Eyu7g1wP1XerEpS
 awAQ==
X-Gm-Message-State: AOAM5302G0ZkwVaMoi/vhwp+heK5ZSnArRAe+glmCbg6CBEDLmx6ED8U
 wPS9jv57Rb9IgIDuUfyblHuQ6SpP+MY=
X-Google-Smtp-Source: ABdhPJx4SKSqhWCTBKt71c9mUyCbwOzW/Dhxvut5uxQjNprBZQEElLl4SwezqH8s23ZuWZ+/ZzYIBQ==
X-Received: by 2002:a7b:cd83:: with SMTP id y3mr25972544wmj.5.1592952365662;
 Tue, 23 Jun 2020 15:46:05 -0700 (PDT)
Received: from lili ([2a01:e0a:59b:9120:65d2:2476:f637:db1e])
 by smtp.gmail.com with ESMTPSA id s5sm5581226wmj.18.2020.06.23.15.46.04
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 23 Jun 2020 15:46:05 -0700 (PDT)
From: zimoun <zimon.toutoune@HIDDEN>
To: Marinus <marinus.savoritias@HIDDEN>, 42009 <at> debbugs.gnu.org
Subject: Re: bug#42009: package.cache not deterministic
In-Reply-To: <20200622190742.04a62732@HIDDEN>
References: <20200622190742.04a62732@HIDDEN>
Date: Wed, 24 Jun 2020 00:46:04 +0200
Message-ID: <86ftalqu37.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 42009
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Dear,

Thank you for the bug report.  It is something already noticed [1] but
without a clean bug report to track it. :-)

1: http://issues.guix.gnu.org/issue/39258#86


On Mon, 22 Jun 2020 at 19:07, Marinus <marinus.savoritias@HIDDEN> wrot=
e:

> Run into a determinism problem today with guix pull.
> I run guix pull --rounds=3D3 but guix ended in error that the result
> wasn't the same.

For reproducing, the simplest is:

--8<---------------cut here---------------start------------->8---
$ guix build --check --no-grafts -K \
   $(guix gc --derivers \
      $(readlink -f ~/.config/guix/current/lib/guix/package.cache))
The following profile hooks will be built:
   /gnu/store/l50sinckbl1y0fz2y4yk4vvfdvay9c8l-guix-package-cache.drv
   /gnu/store/h69hdf14c11q7dip0gssfd4cv0qw8j7k-guix-package-cache.drv
building package cache...
(repl-version 0 1 1)
Generating package cache for '/gnu/store/67zi87xwv2d90kx8pzxsbw2q7qkh11ns-p=
rofile'...
(values (value "/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-ca=
che/lib/guix/package.cache"))
guix build: error: derivation `/gnu/store/h69hdf14c11q7dip0gssfd4cv0qw8j7k-=
guix-package-cache.drv' may not be deterministic: output `/gnu/store/0009wh=
xhfz00lm027wbars8q4wb3rvia-guix-package-cache' differs
--8<---------------cut here---------------end--------------->8---

Then the usual "diffoscope":

--8<---------------cut here---------------start------------->8---
diffoscope \
/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache/lib/guix/pac=
kage.cache \
/gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache-check/lib/gu=
ix/package.cache\
  | head -n50
--8<---------------cut here---------------end--------------->8---

outputs something like:

--8<---------------cut here---------------start------------->8---
--- /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache/lib/guix=
/package.cache
+++ /gnu/store/0009whxhfz00lm027wbars8q4wb3rvia-guix-package-cache-check/li=
b/guix/package.cache
=E2=94=9C=E2=94=80=E2=94=80 readelf --wide --file-header {}
=E2=94=82 @@ -6,15 +6,15 @@
=E2=94=82    OS/ABI:                            <unknown: ff>
=E2=94=82    ABI Version:                       0
=E2=94=82    Type:                              DYN (Shared object file)
=E2=94=82    Machine:                           None
=E2=94=82    Version:                           0x1
=E2=94=82    Entry point address:               0x0
=E2=94=82    Start of program headers:          64 (bytes into file)
=E2=94=82 -  Start of section headers:          4900296 (bytes into file)
=E2=94=82 +  Start of section headers:          4900456 (bytes into file)
=E2=94=82    Flags:                             0x0
=E2=94=82    Size of this header:               64 (bytes)
=E2=94=82    Size of program headers:           56 (bytes)
=E2=94=82    Number of program headers:         3
=E2=94=82    Size of section headers:           64 (bytes)
=E2=94=82    Number of section headers:         20
=E2=94=82    Section header string table index: 17
=E2=94=9C=E2=94=80=E2=94=80 readelf --wide --program-header {}
=E2=94=82 @@ -1,16 +1,16 @@
=E2=94=82=20=20
=E2=94=82  Elf file type is DYN (Shared object file)
=E2=94=82  Entry point 0x0
=E2=94=82  There are 3 program headers, starting at offset 64
=E2=94=82=20=20
=E2=94=82  Program Headers:
=E2=94=82    Type           Offset   VirtAddr           PhysAddr           =
FileSiz  MemSiz   Flg Align
=E2=94=82 -  LOAD           0x000000 0x0000000000000000 0x0000000000000000 =
0x286a68 0x286a68 R   0x10000
=E2=94=82 -  LOAD           0x290000 0x0000000000290000 0x0000000000290000 =
0x21c5c8 0x21c5c8 RW  0x10000
=E2=94=82 -  DYNAMIC        0x286a08 0x0000000000286a08 0x0000000000286a08 =
0x000060 0x000060 R   0x8
=E2=94=82 +  LOAD           0x000000 0x0000000000000000 0x0000000000000000 =
0x286b78 0x286b78 R   0x10000
=E2=94=82 +  LOAD           0x290000 0x0000000000290000 0x0000000000290000 =
0x21c668 0x21c668 RW  0x10000
=E2=94=82 +  DYNAMIC        0x286b18 0x0000000000286b18 0x0000000000286b18 =
0x000060 0x000060 R   0x8
=E2=94=82=20=20
=E2=94=82   Section to Segment mapping:
=E2=94=82    Segment Sections...
=E2=94=82     00     .rodata .rtl-text .dynamic=20=20
=E2=94=82     01     .data=20
=E2=94=82     02     .dynamic
=E2=94=9C=E2=94=80=E2=94=80 readelf --wide --sections {}
=E2=94=82=E2=94=84 stderr from `readelf --wide --sections {}`:
=E2=94=82=E2=94=84 readelf: Warning: [ 5]: Link field (0) should index a st=
ring section.
=E2=94=82 @@ -1,29 +1,29 @@
=E2=94=82 -There are 20 section headers, starting at offset 0x4ac5c8:
=E2=94=82 +There are 20 section headers, starting at offset 0x4ac668:
--8<---------------cut here---------------end--------------->8---

Well, I do not know what should the next step.  I mean this
"package.cache" file is created by the function
gnu/packages.scm:(generate-package-cache) which reads:

--8<---------------cut here---------------start------------->8---
      ;; Store the cache as a '.go' file.  This makes loading fast and redu=
ces
      ;; heap usage since some of the static data is directly mmapped.
      (put-bytevector port
                      (compile `'(,@exp)
                               #:to 'bytecode
                               #:opts '(#:to-file? #t)))))
--8<---------------cut here---------------end--------------->8---

Then it is on the Guile side, isn't it?=20


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 22 Jun 2020 17:25:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 22 13:25:15 2020
Received: from localhost ([127.0.0.1]:34467 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jnQC3-0005Fu-8u
	for submit <at> debbugs.gnu.org; Mon, 22 Jun 2020 13:25:15 -0400
Received: from lists.gnu.org ([209.51.188.17]:52096)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <marinus.savoritias@HIDDEN>) id 1jnPvF-0004qc-7C
 for submit <at> debbugs.gnu.org; Mon, 22 Jun 2020 13:07:55 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:53894)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <marinus.savoritias@HIDDEN>)
 id 1jnPvF-00088Q-1Z
 for bug-guix@HIDDEN; Mon, 22 Jun 2020 13:07:53 -0400
Received: from knopi.disroot.org ([178.21.23.139]:47350)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <marinus.savoritias@HIDDEN>)
 id 1jnPvC-0003Sk-DT
 for bug-guix@HIDDEN; Mon, 22 Jun 2020 13:07:52 -0400
Received: from localhost (localhost [127.0.0.1])
 by disroot.org (Postfix) with ESMTP id D9FE346A10
 for <bug-guix@HIDDEN>; Mon, 22 Jun 2020 19:07:46 +0200 (CEST)
X-Virus-Scanned: Debian amavisd-new at disroot.org
Received: from knopi.disroot.org ([127.0.0.1])
 by localhost (disroot.org [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id h9toMca_5guv for <bug-guix@HIDDEN>;
 Mon, 22 Jun 2020 19:07:45 +0200 (CEST)
Date: Mon, 22 Jun 2020 19:07:42 +0200
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=disroot.org; s=mail;
 t=1592845665; bh=iH4cb5MxllYL56Y4UIjZ6+ovj9c2SjqVF6w0TGGF5s4=;
 h=Date:From:To:Subject;
 b=Imvhrg6d4955Fha2wvsmk0ZNuDn6yUH+gHujWwMMCU3xeumJmHvXOHBHrT5gAztas
 C99QMRPhXxlv31wEhUPGqSTMZFI6WceaOzPUHuZFWkAmJWFDol3Ak5N/GJHcB0bykV
 /9ePhnS5yBHBaW5ha0WEtOJOON0g7tMJ5hUsz9z1CTh3APKnBTFV0BRDyP/o02JCD0
 r024HobpCc+2EBrnBSHHjl7eydGJe79DlMzcQQJ9j0xJmoaieKaH69599v+TylBY1G
 ZZBH+xxnrsBysxIi/52m3ISpnlINhT8LatSbaWjsPmmafezjWTeDSB7b/22k4vi7qv
 RF328iZXaU6DA==
From: Marinus <marinus.savoritias@HIDDEN>
To: bug-guix@HIDDEN
Subject: Determinism problem with guix pull
Message-ID: <20200622190742.04a62732@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
Received-SPF: pass client-ip=178.21.23.139;
 envelope-from=marinus.savoritias@HIDDEN; helo=knopi.disroot.org
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/06/22 13:07:47
X-ACL-Warn: Detected OS   = Linux 2.2.x-3.x [generic]
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_NONE=-0.0001, RCVD_IN_MSPIKE_H3=-0.01, RCVD_IN_MSPIKE_WL=-0.01,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001, URIBL_BLOCKED=0.001 autolearn=_AUTOLEARN
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Mon, 22 Jun 2020 13:25:12 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

Hi,

Run into a determinism problem today with guix pull.
I run guix pull --rounds=3D3 but guix ended in error that the result
wasn't the same.

The error was this:
building package cache...
|output
=E2=80=98/gnu/store/277s1r2kxw9pfw1g6wg3vf6wrkksj57y-guix-package-cache=E2=
=80=99 of
=E2=80=98/gnu/store/m64b2g2h75xbbnrxxn3g1h4833i58yj4-guix-package-cache.drv=
=E2=80=99
differs from previous round build of
/gnu/store/m64b2g2h75xbbnrxxn3g1h4833i58yj4-guix-package-cache.drv
failed View build log at
'/var/log/guix/drvs/m6/4b2g2h75xbbnrxxn3g1h4833i58yj4-guix-package-cache.dr=
v.bz2'.
cannot build derivation
`/gnu/store/bcpjm4yvslpf4858lx4pj89xj279z5nv-profile.drv': 1
dependencies couldn't be built guix pull: error: build of
`/gnu/store/bcpjm4yvslpf4858lx4pj89xj279z5nv-profile.drv' failed

The files are indeed different size with one being larger than the
other.

My system is this:
guix describe
Generation 7	Jun 18 2020 13:55:17	(current)
  guix e418c3d
    repository URL: https://git.savannah.gnu.org/git/guix.git
    branch: master
    commit: e418c3d076ec301a2deda42568035d75f5ed174d


Marinus




Acknowledgement sent to Marinus <marinus.savoritias@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#42009; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 29 Jun 2020 12:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.